/*
 * Part of the solution for Assignment 2 (CSC 218, Winter 2003), by
 * Stefan Bruda.
 */
#include "btree.h"

btree mknode(char* info, btree l, btree r, btree p) {
  btree ret = new node;
  ret -> info = info;
  ret -> parent = p;
  ret -> left = l;
  ret -> right = r;
  return ret;
}

btree deltree (btree tree, btree node) {
  if (tree == empty) // nothing to do, cool
    return empty;
  // delete the children of our node (recursive calls):
  if (node -> left != empty) {
    deltree (tree,node -> left);
  }
  if (node -> right != empty) {
    deltree (tree,node -> right);
  }
  // node -> left, node -> right are now disposed of,
  // we set the links in the parent:
  if (node -> parent != empty) {
    if (node -> parent -> left != empty && 
        node -> parent -> left == node)
      node -> parent -> left = empty;
    if (node -> parent -> right != empty && 
        node -> parent -> right == node)
      node -> parent -> right = empty;
  }
  // finally, delete the node and return the (new) tree:
  delete node;
  if (node == tree)
    return empty;
  else
    return tree;
}

char* key (btree t) {
  return t -> info;
}

btree lefttree (btree t) {
  return t -> left;
}
btree righttree (btree t) {
  return t -> right;
}

btree parent(btree t) {
  return t -> parent;
}

void indent(int level) { // auxiliary for printtree
  for (int i = 0; i < level; i++)
    cout << "   ";
  cout.flush();
}

void printtree (btree t, int level) {
  indent(level);
  cout << "[" << t << "] ";
  if (t != empty) {
    cout << "\"" << key(t) << "\"" << " ";
    cout << "[parent: " << parent(t) << "]\n";
    if (lefttree(t) != empty) {
      indent(level);
      cout << "left:\n";
      printtree(lefttree(t), level+1);
    }
    if (righttree(t) != empty) {
      indent(level);
      cout << "right:\n";
      printtree(righttree(t), level+1);
    }
  }
  else
    cout << "\n";
}
