/*
 * Part of the solution for Assignment 2 (CSC 218, Winter 2003), by
 * Stefan Bruda.
 */
#include "treesort.h"

/*
 * Reads a number n and n lines of text.  Prints back the read lines,
 * but sorted in lexicographic order.
 */

int main (int argc, char** argv) {
  int n;

  // Allocate space for, and read input:
  cin >> n;
  if (n < 0)   // no negative allocations, this really asks for
    return 1;  // buffer overflows

  char** strs = new char*[n];

  cin.ignore(); // eat up the extra end of line...

  for (int i = 0; i < n; i++) {
    char* newstr = new char[1025]; // 1024 + strlen('\0') = 1025 !
    cin.getline(newstr,1025);
    strs[i] = newstr;
  }

  // Sort the input:
  treesort(strs,n);

  // Display the result:
  for (int i = 0; i < n; i++)
    cout << strs[i] << "\n";

  // Release allocated memory.  This is not quite necessary since the
  // program terminates anyway and its heap gets thus deallocated.
  for (int i = 0; i < n; i++)
    delete[] strs[i];
  delete[] strs;
}
