/*
 * Part of the solution for Assignment 2 (CSC 218, Winter 2003), by
 * Stefan Bruda.
 */
#ifndef __STREE_H
#define __STREE_H

#include <string.h>
#include "btree.h"

/*
 * Note: I took the liberty to reverse the order of arguments for
 * mamtree and instree, because I found it easier to build test trees
 * this way (although this is just a matter of taste...).
 */

/*
 * memtree(s,t) searches for the first occurrence of s in t and
 * returns the corresponding node.  Assumes that t is a search tree.
 * Returns empty (see the btree module) when s is not in t.
 */
btree memtree(char*, btree);

/*
 * instree(s,t) inserts s into t and returns the newly created tree.
 * Returns a search tree iff t is a search tree.
 */
btree instree(char*, btree);

/*
 * delnode(t,n) deletes node n (and only node n) from tree t and
 * returns the result.  Returns a search tree iff t is a search tree.
 */
btree delnode(btree, btree);

#endif /* __STREE_H */
